#include "boucane.hpp"
#include "core/idt.hpp"
#include "boot/multiboot2.hpp"
#include "core/paging.hpp"
#include "core/apic.hpp"
#include "drivers/acpi.hpp"

extern u32 MB_INFO;

extern "C" void boucane(){
    clear();
    printk("Booting Boucane v%d.%d.%d\n",VERSION_MAJOR,VERSION_MINOR, VERSION_PATH);
    idt_enable_interrupt();

    paging_enable();
    //apic_enable();

    u64 p;
    u32 size;
    if(mb2_find_old_rsdp((u32*)MB_INFO,&p,&size)){
        acpi_load_madt((void*)p);
    }
    while(1);
}